| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Data Structures | Functions
HID Class Device Mode Driver
HID Class Driver

## Data Structures
struct | USB_ClassInfo_HID_Device_t
| HID Class Device Mode Configuration and State Structure. More...

## Functions
bool | CALLBACK_HID_Device_CreateHIDReport (USB_ClassInfo_HID_Device_t *const HIDInterfaceInfo, uint8_t *const ReportID, const uint8_t ReportType, void *ReportData, uint16_t *const ReportSize) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2) ATTR_NON_NULL_PTR_ARG(4) ATTR_NON_NULL_PTR_ARG(5)
void | CALLBACK_HID_Device_ProcessHIDReport (USB_ClassInfo_HID_Device_t *const HIDInterfaceInfo, const uint8_t ReportID, const uint8_t ReportType, const void *ReportData, const uint16_t ReportSize) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(4)
bool | HID_Device_ConfigureEndpoints (USB_ClassInfo_HID_Device_t *const HIDInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
static void | HID_Device_MillisecondElapsed (USB_ClassInfo_HID_Device_t *const HIDInterfaceInfo) ATTR_ALWAYS_INLINE ATTR_NON_NULL_PTR_ARG(1)
void | HID_Device_ProcessControlRequest (USB_ClassInfo_HID_Device_t *const HIDInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
void | HID_Device_USBTask (USB_ClassInfo_HID_Device_t *const HIDInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)

## Detailed Description

# Module Source Dependencies

The following files must be built with any user project that uses this module:

- LUFA/Drivers/USB/Class/Device/HIDClassDevice.c (Makefile source module name: LUFA_SRC_USBCLASS)

# Module Description

Device Mode USB Class driver framework interface, for the HID USB Class driver.

## Function Documentation

bool CALLBACK_HID_Device_CreateHIDReport | ( | USB_ClassInfo_HID_Device_t *const | HIDInterfaceInfo,
|  | uint8_t *const | ReportID,
|  | const uint8_t | ReportType,
|  | void * | ReportData,
|  | uint16_t *const | ReportSize
| ) |  |

HID class driver callback for the user creation of a HID IN report. This callback may fire in response to either HID class control requests from the host, or by the normal HID endpoint polling procedure. Inside this callback the user is responsible for the creation of the next HID input report to be sent to the host.

Parameters

  [in,out] | HIDInterfaceInfo | Pointer to a structure containing a HID Class configuration and state.
  [in,out] | ReportID | If preset to a non-zero value, this is the report ID being requested by the host. If zero, this should be set to the report ID of the generated HID input report (if any). If multiple reports are not sent via the given HID interface, this parameter should be ignored.
  [in] | ReportType | Type of HID report to generate, either HID_REPORT_ITEM_In or HID_REPORT_ITEM_Feature.
  [out] | ReportData | Pointer to a buffer where the generated HID report should be stored.
  [out] | ReportSize | Number of bytes in the generated input report, or zero if no report is to be sent.

Returns
  Boolean `true` to force the sending of the report even if it is identical to the previous report and still within the idle period (useful for devices which report relative movement), `false` otherwise.

void CALLBACK_HID_Device_ProcessHIDReport | ( | USB_ClassInfo_HID_Device_t *const | HIDInterfaceInfo,
|  | const uint8_t | ReportID,
|  | const uint8_t | ReportType,
|  | const void * | ReportData,
|  | const uint16_t | ReportSize
| ) |  |

HID class driver callback for the user processing of a received HID OUT report. This callback may fire in response to either HID class control requests from the host, or by the normal HID endpoint polling procedure. Inside this callback the user is responsible for the processing of the received HID output report from the host.

Parameters

  [in,out] | HIDInterfaceInfo | Pointer to a structure containing a HID Class configuration and state.
  [in] | ReportID | Report ID of the received output report. If multiple reports are not received via the given HID interface, this parameter should be ignored.
  [in] | ReportType | Type of received HID report, either HID_REPORT_ITEM_Out or HID_REPORT_ITEM_Feature.
  [in] | ReportData | Pointer to a buffer where the received HID report is stored.
  [in] | ReportSize | Size in bytes of the received report from the host.

bool HID_Device_ConfigureEndpoints | ( | USB_ClassInfo_HID_Device_t *const | HIDInterfaceInfo | ) |

Configures the endpoints of a given HID interface, ready for use. This should be linked to the library EVENT_USB_Device_ConfigurationChanged() event so that the endpoints are configured when the configuration containing the given HID interface is selected.

Parameters

  [in,out] | HIDInterfaceInfo | Pointer to a structure containing a HID Class configuration and state.

Returns
  Boolean `true` if the endpoints were successfully configured, `false` otherwise.

static void HID_Device_MillisecondElapsed | ( | USB_ClassInfo_HID_Device_t *const | HIDInterfaceInfo | ) |
| inline static

Indicates that a millisecond of idle time has elapsed on the given HID interface, and the interface's idle count should be decremented. This should be called once per millisecond so that hardware key-repeats function correctly. It is recommended that this be called by the EVENT_USB_Device_StartOfFrame() event, once SOF events have been enabled via USB_Device_EnableSOFEvents().

Parameters

  [in,out] | HIDInterfaceInfo | Pointer to a structure containing a HID Class configuration and state.

void HID_Device_ProcessControlRequest | ( | USB_ClassInfo_HID_Device_t *const | HIDInterfaceInfo | ) |

Processes incoming control requests from the host, that are directed to the given HID class interface. This should be linked to the library EVENT_USB_Device_ControlRequest() event.

Parameters

  [in,out] | HIDInterfaceInfo | Pointer to a structure containing a HID Class configuration and state.

void HID_Device_USBTask | ( | USB_ClassInfo_HID_Device_t *const | HIDInterfaceInfo | ) |

General management task for a given HID class interface, required for the correct operation of the interface. This should be called frequently in the main program loop, before the master USB management task USB_USBTask().

Parameters

  [in,out] | HIDInterfaceInfo | Pointer to a structure containing a HID Class configuration and state.